zoukankan      html  css  js  c++  java
  • CodeForces 164 B. Ancient Berland Hieroglyphs 单调队列

    B. Ancient Berland Hieroglyphs

    题目连接:

    http://codeforces.com/problemset/problem/164/B

    Descriptionww.co

    Polycarpus enjoys studying Berland hieroglyphs. Once Polycarp got hold of two ancient Berland pictures, on each of which was drawn a circle of hieroglyphs. We know that no hieroglyph occurs twice in either the first or the second circle (but in can occur once in each of them).

    Polycarpus wants to save these pictures on his laptop, but the problem is, laptops do not allow to write hieroglyphs circles. So Polycarp had to break each circle and write down all of its hieroglyphs in a clockwise order in one line. A line obtained from the first circle will be called a, and the line obtained from the second one will be called b.

    There are quite many ways to break hieroglyphic circles, so Polycarpus chooses the method, that makes the length of the largest substring of string a, which occurs as a subsequence in string b, maximum.

    Help Polycarpus — find the maximum possible length of the desired substring (subsequence) if the first and the second circles are broken optimally.

    The length of string s is the number of characters in it. If we denote the length of string s as |s|, we can write the string as s = s1s2... s|s|.

    A substring of s is a non-empty string x = s[a... b] = sasa + 1... sb (1 ≤ a ≤ b ≤ |s|). For example, "code" and "force" are substrings of "codeforces", while "coders" is not.

    A subsequence of s is a non-empty string y = s[p1p2... p|y|] = sp1sp2... sp|y| (1 ≤ p1 < p2 < ... < p|y| ≤ |s|). For example, "coders" is a subsequence of "codeforces".

    Input

    The first line contains two integers la and lb (1 ≤ la, lb ≤ 1000000) — the number of hieroglyphs in the first and second circles, respectively.

    Below, due to difficulties with encoding of Berland hieroglyphs, they are given as integers from 1 to 106.

    The second line contains la integers — the hieroglyphs in the first picture, in the clockwise order, starting with one of them.

    The third line contains lb integers — the hieroglyphs in the second picture, in the clockwise order, starting with one of them.

    It is guaranteed that the first circle doesn't contain a hieroglyph, which occurs twice. The second circle also has this property.

    Output

    Print a single number — the maximum length of the common substring and subsequence. If at any way of breaking the circles it does not exist, print 0.

    Sample Input

    5 4

    1 2 3 4 5

    1 3 5 6

    Sample Output

    2

    Hint

    题意

    给你两个字符串

    这两个字符串都是环状的

    你需要在第一个字符串里面找到一个最长子串是第二个字符串的子序列

    题解:

    单调队列,队列里面存的是从小到大的a[i]的位置

    我们队列维护的时候,以a[i]这个数结尾的话,能够得到的最大的长度

    由于这个东西是个环,所以我们直接让第二个字符串转到他的前面就好了,这样就所有的位置都小于他了

    比如你队列的数字已经是2 5 7了,m为6。

    现在你要插入一个6怎么办?

    因为6<7,所以我们6+m = 12,然后把12插进去就好了

    由于2<12-m 5<12-m,所以我们把2和5都弹出去。

    队列就变成了 7 12

    如果再插一个5怎么办,我们让5 + 2*m就好了

    再弹出去7

    就变成12 17

    代码

    #include<bits/stdc++.h>
    using namespace std;
    
    const int maxn = 1e6*2+5;
    int n,m;
    int a[maxn];
    int b[maxn];
    int c[maxn];
    int main()
    {
        memset(c,-1,sizeof(c));
        scanf("%d%d",&n,&m);
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        for(int i=0;i<m;i++)
        {
            scanf("%d",&b[i]);
            c[b[i]]=i;
        }
        int ans = 0;
        queue<long long> Q;
        for(int i=0;i<2*n;i++)
        {
            long long p = c[a[i%n]];
            if(p==-1)while(!Q.empty())Q.pop();
            else{
                if(Q.size()&&p<=Q.back())
                    p+=(Q.back()-p+m)/m*m;
                Q.push(p);
                while(p-Q.front()>=m)
                    Q.pop();
            }
            ans=max(ans,(int)Q.size());
        }
        printf("%d
    ",ans);
    }
  • 相关阅读:
    Leetcode 50.Pow(x,n) By Python
    Leetcode 347.前K个高频元素 By Python
    Leetcode 414.Fizz Buzz By Python
    Leetcode 237.删除链表中的节点 By Python
    Leetcode 20.有效的括号 By Python
    Leetcode 70.爬楼梯 By Python
    Leetcode 190.颠倒二进制位 By Python
    团体程序设计天梯赛 L1-034. 点赞
    Wannafly挑战赛9 C-列一列
    TZOJ Start
  • 原文地址:https://www.cnblogs.com/qscqesze/p/5149567.html
Copyright © 2011-2022 走看看